# Unicorn-OSAL

This framework provide an Operating System Abstraction Layer

While the utlimate goal is to provide a framework implementation of the FreeRTOS library,
the project aims to support every RTOS.


## Contributing
 
Contributions to this project are welcome. Please see the contribution guidelines [here](CONTRIBUTING.md)

### Develoment Setup
The simplest way to get started contributing with this project is to open it with the [VS Code](https://code.visualstudio.com/) editor specifically the [Remote Containers extension](https://marketplace.visualstudio.com/items?itemName=ms-vscode-remote.remote-containers)

A `dev-container` has been defined. Before trying to open the development environment, make sure you've performed the following steps:

- You have installed and can run docker on your development pc. [If not click here](https://drive.google.com/file/d/1a9ZsLOmFzJaq4EH6tsha7Votmf_WXh2G/view?usp=sharing)

When ready perform the following steps to open the development environment:

1. Open the root folder of this git repository in VS Code
2. Press `Ctrl+Shift+P` to open the _VS Code Command Palette_
3. Enter _Remote Containers: Open Workspace in Container..._ in the palette and press `Enter`

VS Code will now start initializing the development environment. This may take a few minutes the first time. Once completed, you'll be able to work on this project from within a qualifed container.

We invite you to check how to setup your [C++ IntelliSense](https://git.step.polymtl.ca/machine-epm/unicorn-hal/-/wikis/VS-Code/C---IntelliSense)

### Configure Project

This project has a set of task to help you to configure your project.

1. Via the command palette
	1. Press `Ctrl+Shift+P` to open the _VS Code Command Palette_
	2. Enter _Tasks: Run Task_ in the palette and press `Enter`
	3. Choose _Configure Project_ and press `Enter`
	4. Choose the _Arm cortex-M0_ and press `Enter`

2. When VS Code open the root folder
	1. Choose the _Arm cortex-M0_ and press `Enter`

### Build Project
This project has a set of task to help you to build your project. Be sure to have run at least one time the _Configure Project_.

1. Press `Ctrl+Shift+P` to open the _VS Code Command Palette_
2. Enter _Tasks: Run Task_ in the palette and press `Enter`
3. Choose _Build Project_ and press `Enter`


## Contact

If you need to reach anybody to discuss this project, please contact:

| Address                                                         |
| --------------------------------------------------------------- |
| [ahmad.faour@polymtl.ca](mailto:ahmad.faour@polymtl.ca)         |
| [gaya.mehenni@polymtl.ca](mailto:gaya.mehenni@polymtl.ca) 	  |
