#include "../semaphore.hpp"

namespace osal {

/**
 * @brief Classe englobant le semaphore binaire de FreeRTOS
 *
 */
class BinarySemaphore : public FreeRtosSemaphore {
   public:
	BinarySemaphore(const char* name, bool isLocked = false)
	    : FreeRtosSemaphore(name, initSemaphore()) {
		if (!isLocked)
			this->give();
	}

	virtual SemaphoreHandle_t initSemaphore() override {
		return xSemaphoreCreateBinaryStatic(&buffer);
	}

	virtual ~BinarySemaphore() {}
};

}
