#include "../semaphore.hpp"

namespace osal {

/**
 * @brief Classe englobant le semaphore counted de FreeRTOS
 *
 */
class CountingSemaphore : public FreeRtosSemaphore {
   public:
	CountingSemaphore(const char* name, uint8_t maxCount, uint8_t intialCount)
	    : FreeRtosSemaphore(name, initSemaphore()),
	      m_maxCount(maxCount),
	      m_intialCount(intialCount) {}

	virtual SemaphoreHandle_t initSemaphore() override {
		return xSemaphoreCreateCountingStatic(m_maxCount, m_intialCount,
		                                      &buffer);
	}

	virtual ~CountingSemaphore() {}

   private:
	const uint8_t m_maxCount;
	const uint8_t m_intialCount;
};

}
