#include "../semaphore.hpp"

namespace osal {

/**
 * @brief Classe englobant le semaphore mutex de FreeRTOS. La différence entre
 * un mutex et un semaphore binaire est que le mutex utilise l'heritage de
 * priorité.
 *
 */
class Mutex : public FreeRtosSemaphore {
   public:
	Mutex(const char* name, bool isLocked = false)
	    : FreeRtosSemaphore(name, initSemaphore()) {
		if (!isLocked)
			this->give();
	}

	virtual SemaphoreHandle_t initSemaphore() override {
		return xSemaphoreCreateMutexStatic(&buffer);
	}

	virtual ~Mutex() {}
};

}  // namespace osal
